Bug 840126 - redundant DW_TAG_GNU_call_site_parameter-DW_AT_abstract_origin
redundant DW_TAG_GNU_call_site_parameter-DW_AT_abstract_origin
Status: CLOSED EOL
Product: Fedora
Classification: Fedora
Component: dwz (Show other bugs)
19
x86_64 Linux
unspecified Severity low
: ---
: ---
Assigned To: Jakub Jelinek
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-07-13 15:23 EDT by Jan Kratochvil
Modified: 2015-02-17 09:21 EST (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2015-02-17 09:21:02 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
xorg-x11-server-1.12.3-1.fc18 Xorg.debug.xz original (2.22 MB, application/octet-stream)
2012-07-13 15:28 EDT, Jan Kratochvil
no flags Details
xorg-x11-server-1.12.3-1.fc18 Xorg.debug.xz dwz-optimized (1.81 MB, application/octet-stream)
2012-07-13 15:30 EDT, Jan Kratochvil
no flags Details

  None (edit)
Description Jan Kratochvil 2012-07-13 15:23:34 EDT
Description of problem:
Currently dwz-optimized DWARF may cause GDB internal-error (Bug 839596).
Going to fix GDB but that DWARF construct has no use anyway so posting it as missed DWZ optimization here.

Version-Release number of selected component (if applicable):
dwz-0.5-1.fc18.x86_64

How reproducible:
Always.

Steps to Reproduce:
dwz Xorg.debug

original Xorg.debug:
 <0><1409ed>: Abbrev Number: 1 (DW_TAG_compile_unit)
 <2><14637c>: Abbrev Number: 50 (DW_TAG_formal_parameter)
    <14637d>   DW_AT_name        : key
    <146381>   DW_AT_decl_file   : 2
    <146382>   DW_AT_decl_line   : 114
    <146383>   DW_AT_type        : <0x14639b>
 <2><146711>: Abbrev Number: 66 (DW_TAG_GNU_call_site)
    <146712>   DW_AT_low_pc      : 0x48894d
    <14671a>   DW_AT_abstract_origin: <0x146595>
 <3><14671e>: Abbrev Number: 74 (DW_TAG_GNU_call_site_parameter)
    <14671f>   DW_AT_abstract_origin: <0x14637c>
    <146723>   DW_AT_GNU_call_site_value: 3 byte block: f3 1 54         (DW_OP_GNU_entry_value: (DW_OP_reg4 (rsi)))
not found: DW_OP_GNU_parameter_ref: <0x14637c>

optimized Xorg.debug:
 <0><1c2a8>: Abbrev Number: 2 (DW_TAG_partial_unit)
 <2><1c2dc>: Abbrev Number: 96 (DW_TAG_formal_parameter)
    <1c2dd>   DW_AT_name        : key
    <1c2e1>   DW_AT_decl_file   : 2
    <1c2e2>   DW_AT_decl_line   : 114
    <1c2e3>   DW_AT_type        : <0x1c2f5>
 <0><110990>: Abbrev Number: 79 (DW_TAG_compile_unit)
 <2><1134cd>: Abbrev Number: 115 (DW_TAG_GNU_call_site)
    <1134ce>   DW_AT_low_pc      : 0x48894d
    <1134d6>   DW_AT_abstract_origin: <0x113370>
 <3><1134d8>: Abbrev Number: 106 (DW_TAG_GNU_call_site_parameter)
    <1134d9>   DW_AT_abstract_origin: <0x1c2dc>
    <1134dd>   DW_AT_GNU_call_site_value: 3 byte block: f3 1 54         (DW_OP_GNU_entry_value: (DW_OP_reg4 (rsi)))
not found: DW_OP_GNU_parameter_ref: <0x1c2dc>

In optimized DWARF DW_TAG_GNU_call_site_parameter-DW_AT_abstract_origin points outside of its CU which was problem for GDB.

But as no callee is referencing this DIE <0x1c2dc> by DW_OP_GNU_parameter_ref this DIE can be dropped.  No other CU can use the intra-cu binding DW_OP_GNU_parameter_ref-DW_TAG_GNU_call_site_parameter-DW_AT_abstract_origin.
Comment 1 Jan Kratochvil 2012-07-13 15:28:32 EDT
Created attachment 598155 [details]
xorg-x11-server-1.12.3-1.fc18 Xorg.debug.xz original
Comment 2 Jan Kratochvil 2012-07-13 15:30:43 EDT
Created attachment 598157 [details]
xorg-x11-server-1.12.3-1.fc18 Xorg.debug.xz dwz-optimized
Comment 3 Jan Kratochvil 2012-07-13 15:46:30 EDT
As DW_OP_GNU_parameter_ref uses CU-relative reference in fact DW_TAG_GNU_call_site_parameter-DW_AT_abstract_origin cannot be moved into DW_TAG_partial_unit even if it was referenced (dwz probably already solves it although I do not know).
Comment 4 Fedora End Of Life 2013-04-03 11:05:43 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 19 development cycle.
Changing version to '19'.

(As we did not run this process for some time, it could affect also pre-Fedora 19 development
cycle bugs. We are very sorry. It will help us with cleanup during Fedora 19 End Of Life. Thank you.)

More information and reason for this action is here:
https://fedoraproject.org/wiki/BugZappers/HouseKeeping/Fedora19
Comment 5 Fedora End Of Life 2015-01-09 12:15:18 EST
This message is a notice that Fedora 19 is now at end of life. Fedora 
has stopped maintaining and issuing updates for Fedora 19. It is 
Fedora's policy to close all bug reports from releases that are no 
longer maintained. Approximately 4 (four) weeks from now this bug will
be closed as EOL if it remains open with a Fedora 'version' of '19'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 19 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 6 Fedora End Of Life 2015-02-17 09:21:02 EST
Fedora 19 changed to end-of-life (EOL) status on 2015-01-06. Fedora 19 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.